//---------------------------------------------------------------------------

#ifndef batchItH
#define batchItH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "CZT_FFT_Utils_Framework.h"
#include "CWavIterator.h"
#include "CZT_FeatureCalc.h"
#include <Forms.hpp>
#include <FileCtrl.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Graphics.hpp>
#include "SDL_NumLab.hpp"
#include "SDL_matrix.hpp"
#include <AppEvnts.hpp>
#include "SDL_NumLab.hpp"
#include "SDL_rchart.hpp"
#include "SDL_plot3d.hpp"
#include <Grids.hpp>
#include <jpeg.hpp>
#include "segmentation.h"


//---------------------------------------------------------------------------
class Tbatch : public TForm
{
__published:	// IDE-managed Components
	TScrollBox *ScrollBox1;
	TPageControl *sonogram;
	TTabSheet *sonogram_display;
	TPanel *song_panel;
	TSpeedButton *PitchB;
	TSpeedButton *EntropyB;
	TSpeedButton *FMB;
	TSpeedButton *DerivPowerB;
	TSpeedButton *PitchGoodnessB;
	TSpeedButton *PeakFrB;
	TSpeedButton *AM;
	TImage *Image9;
	TNumLab *entropy_val;
	TNumLab *deriv_val;
	TSpeedButton *Draw2;
	TScrollBox *ScrollBox2;
	TImage *Image1;
	TTrackBar *sldrBrightness;
	TRadioGroup *stretch;
	TStaticText *rec1;
	TStringGrid *analysis_summary;
	TTrackBar *entropyTb;
	TTrackBar *derivTB;
	TTabSheet *table_features;
	TNumLab *NumLab4;
	TNumLab *NumLab5;
	TRChart *multi_chart2;
	TStaticText *StaticText19;
	TBitBtn *BitBtn14;
	TBitBtn *BitBtn15;
	TTrackBar *TrackBar3;
	TTrackBar *TrackBar4;
	TPageControl *batch_controls;
	TTabSheet *start_page;
	TStaticText *StaticText43;
	TBitBtn *change_bird;
	TPanel *batch_types;
	TStaticText *StaticText22;
	TRadioGroup *save1;
	TStaticText *StaticText24;
	TStaticText *StaticText25;
	TBitBtn *similarity_batch;
	TBitBtn *raw_to_syll;
	TStaticText *StaticText26;
	TRadioGroup *RadioGroup2;
	TBitBtn *rhythm_batch;
	TStaticText *StaticText21;
	TBitBtn *BitBtn4;
	TRadioGroup *batch_mode;
	TPanel *batch_name_panel;
	TEdit *batch_name1;
	TStaticText *StaticText47;
	TPanel *ref_time;
	TDateTimePicker *hatched;
	TStaticText *StaticText44;
	TBitBtn *batch_choices;
	TStaticText *StaticText46;
	TEdit *batch_name;
	TStaticText *StaticText45;
	TTabSheet *sound_files;
	TRadioGroup *data_type;
	TBitBtn *show_files;
	TStaticText *StaticText14;
	TStaticText *select_waves;
	TBitBtn *test_time_stamp;
	TPanel *time_stamp_panel;
	TStaticText *StaticText27;
	TRadioGroup *format;
	TStaticText *StaticText16;
	TStringGrid *time_stamp;
	TBitBtn *to_segmentation;
	TTabSheet *raw2syll;
	TStaticText *StaticText4;
	TBitBtn *show_rawtosylltables;
	TTabSheet *segmentation;
	TLabel *segment_label;
	TNumLab *NumLab3;
	TNumLab *hp_small_num;
	TNumLab *hp_big_num;
	TNumLab *min_stop_durN;
	TNumLab *bout_Stop_N;
	TStaticText *StaticText28;
	TStaticText *StaticText39;
	TMemo *segmentation_memo;
	TBitBtn *segmentation_done;
	TBitBtn *BitBtn6;
	TStaticText *StaticText32;
	TComboBox *segment_by;
	TCheckBox *smoothGraphCB;
	TCheckBox *adaptThreshCB;
	TStaticText *StaticText49;
	TStaticText *StaticText50;
	TRadioGroup *segmentation_flip;
	TTrackBar *hp_small;
	TTrackBar *hp_big;
	TPanel *secondary_segmentation_panel;
	TNumLab *secondaryThresholdTB;
	TComboBox *secondaryFeatureDD;
	TRadioGroup *secondaryComparisonRB;
	TRadioGroup *secondaryLogicRB;
	TCheckBox *secondaryFeatureCB;
	TStaticText *StaticText30;
	TStaticText *StaticText54;
	TTrackBar *min_stop_durTb;
	TTrackBar *bout_stop;
	TStaticText *StaticText29;
	TStaticText *StaticText6;
	TBitBtn *save;
	TTabSheet *do_rawsyll_batch;
	TPanel *create_tables_panel;
	TBitBtn *create_syllable_table;
	TStaticText *RecordFile1;
	TStaticText *StaticText11;
	TStaticText *RecordsNum;
	TBitBtn *open_file_table;
	TStaticText *StaticText20;
	TEdit *birdname;
	TCheckBox *ignore_errors;
	TBitBtn *done_rawtosyll;
	TBitBtn *resegment;
	TTabSheet *save_criteria;
	TNumLab *min_syllable_durN;
	TRadioGroup *wav_selection;
	TBitBtn *BitBtn5;
	TPanel *saving_thresh;
	TLabel *Label1;
	TLabel *Label18;
	TNumLab *mean_syllable_num;
	TNumLab *BoutDurLow;
	TNumLab *SyllDurLow;
	TStaticText *StaticText13;
	TTrackBar *SyllMinDurTb;
	TTrackBar *BoutMinDurTB;
	TTrackBar *min_syllables;
	TStaticText *StaticText83;
	TStaticText *StaticText10;
	TPanel *move_sounds;
	TRadioGroup *move_options;
	TPanel *move_to;
	TBitBtn *test2;
	TBitBtn *sound_output1;
	TEdit *target_sound_file_folder;
	TBitBtn *to_output;
	TStaticText *StaticText55;
	TTrackBar *min_syllable_durTb;
	TStaticText *StaticText56;
	TTabSheet *output;
	TStaticText *StaticText51;
	TRadioGroup *save_file_table;
	TPanel *file_table_options;
	TStaticText *StaticText48;
	TBitBtn *new_file_tableB;
	TBitBtn *open_file_tbl;
	TEdit *file_table_name1;
	TMemo *Memo1;
	TPanel *syllable_table_panel;
	TEdit *syllable_table_name1;
	TStaticText *StaticText52;
	TBitBtn *BitBtn16;
	TBitBtn *BitBtn20;
	TMemo *Memo2;
	TPanel *raw_table_panel;
	TStaticText *StaticText53;
	TBitBtn *features_output1;
	TBitBtn *change_raw_table;
	TEdit *raw_features1;
	TRadioGroup *daily_raw_tables;
	TEdit *daily_raw_name;
	TStaticText *daily_raw_lb;
	TBitBtn *to_review;
	TTabSheet *setslaves;
	TRadioGroup *slave_state1;
	TRadioGroup *slave_state2;
	TRadioGroup *slave_state3;
	TRadioGroup *slave_state4;
	TRadioGroup *slave_state5;
	TRadioGroup *slave_state6;
	TRadioGroup *slave_state7;
	TRadioGroup *slave_state8;
	TFileListBox *slave_list1;
	TFileListBox *slave_list3;
	TFileListBox *slave_list4;
	TFileListBox *slave_list5;
	TFileListBox *slave_list6;
	TFileListBox *slave_list7;
	TFileListBox *slave_list8;
	TFileListBox *slave_list2;
	TEdit *folder_name1;
	TEdit *folder_name2;
	TEdit *folder_name3;
	TEdit *folder_name4;
	TEdit *folder_name5;
	TEdit *folder_name6;
	TEdit *folder_name7;
	TEdit *folder_name8;
	TRadioGroup *automate_slave_find;
	TBitBtn *BitBtn1;
	TRadioGroup *wait_for_slaves;
	TBitBtn *BitBtn8;
	TRadioGroup *brain_table;
	TRadioGroup *format_old;
	TEdit *year;
	TTabSheet *review;
	TSpeedButton *Draw1;
	TNumLab *files_to_do;
	TBitBtn *batch;
	TBitBtn *BitBtn7;
	TBitBtn *batch_process;
	TBitBtn *batch_count;
	TTrackBar *back_counter;
	TBitBtn *help10;
	TMemo *batch_summary;
	TTabSheet *options;
	TNumLab *char_comp;
	TNumLab *state_transition_Num;
	TNumLab *missmatchesNum;
	TBitBtn *toExcel;
	TBitBtn *toMatlab;
	TCheckBox *equalize;
	TRadioGroup *rawfile_name;
	TBitBtn *BitBtn9;
	TBitBtn *start_formB;
	TStaticText *StaticText3;
	TBitBtn *Delete_recs;
	TTrackBar *char_comp_tb;
	TBitBtn *options1;
	TBitBtn *BitBtn12;
	TStaticText *StaticText215;
	TTrackBar *state_transition_TB;
	TTrackBar *missmatchesTb;
	TStaticText *StaticText216;
	TStaticText *StaticText214;
	TTabSheet *rhythm_settings;
	TNumLab *files_per_rhythm_val;
	TNumLab *rhythms_per_folder_val;
	TRadioGroup *rhythm_feature;
	TRadioGroup *rhythm_filter;
	TRadioGroup *rhythm_range;
	TRChart *rhythm_chart;
	TBitBtn *start_rhythm_batch;
	TStaticText *StaticText7;
	TTrackBar *files_per_rhythmcalc;
	TBitBtn *calc_rhythm;
	TStaticText *StaticText12;
	TStaticText *StaticText18;
	TStaticText *StaticText23;
	TTrackBar *rhythms_per_folder;
	TStaticText *StaticText31;
	TRadioGroup *file_selection;
	TTabSheet *rhythm;
	TImage *Image2;
	TPlot3D *rhythm_spect;
	TTrackBar *angleX;
	TTrackBar *angleZ;
	TCheckBox *do_rhythm;
	TTrackBar *colors;
	TStaticText *StaticText9;
	TTabSheet *progress;
	TPanel *Panel1;
	TLabel *counter;
	TLabel *status;
	TShape *st;
	TLabel *files_processedN;
	TLabel *msCounterN;
	TLabel *files_acceptedN;
	TLabel *syllable_table_name;
	TLabel *ms_table_name;
	TLabel *file_table_name;
	TNumLab *file_table_index;
	TStaticText *StaticText2;
	TStaticText *StaticText1;
	TStaticText *StaticText33;
	TStaticText *StaticText34;
	TStaticText *StaticText35;
	TStaticText *StaticText36;
	TStaticText *StaticText37;
	TStaticText *StaticText38;
	TStaticText *StaticText15;
	TStaticText *StaticText17;
	TStaticText *batch_saving;
	TBitBtn *breakIt;
	TTabSheet *brainsyll;
	TBitBtn *BitBtn13;
	TListBox *multi_tables;
	TBitBtn *create_braintable;
	TRadioGroup *RadioGroup1;
	TListBox *multi_tables_list;
	TBitBtn *add2;
	TBitBtn *multi_segment;
	TRChart *multi_chart;
	TEdit *custom_thresh;
	TStaticText *StaticText42;
	TBitBtn *reset;
	TBitBtn *forward;
	TPageControl *file_panel;
	TTabSheet *select_sounds;
	TDirectoryListBox *DirectoryListBox1;
	TDriveComboBox *DriveComboBox1;
	TFileListBox *soundList;
	TEdit *Edit1;
	TBitBtn *BitBtn3;
	TFileListBox *FileListBox1;
	TStaticText *StaticText5;
	TStaticText *StaticText8;
	TCheckBox *All_subfolders;
	TEdit *active_folder;
	TTabSheet *select_tables;
	TLabel *Label3;
	TLabel *raw_recs;
	TLabel *recsintable;
	TBitBtn *open_raw_table;
	TBitBtn *BitBtn10;
	TListBox *table_batch_list;
	TBitBtn *add;
	TListBox *tables;
	TRadioGroup *age_or_day;
	TOpenDialog *OpenDialog1;
	TApplicationEvents *ApplicationEvents1;
	TTabSheet *parameters;
	TBitBtn *features_calc;
	TBitBtn *goto_parameters;
	TRadioGroup *pitch_method;
	TPanel *Panel12;
	TNumLab *minfr;
	TStaticText *StaticText79;
	TTrackBar *minfr_tb;
	TStaticText *StaticText80;
	TStaticText *StaticText81;
	TPanel *Panel2;
	TNumLab *frequency_range_val;
	TNumLab *windowTB;
	TNumLab *advanceTb;
	TStaticText *StaticText144;
	TTrackBar *frequency_range;
	TStaticText *StaticText126;
	TStaticText *StaticText157;
	TTrackBar *data_window;
	TStaticText *StaticText158;
	TStaticText *StaticText106;
	TTrackBar *advance;
	TStaticText *StaticText188;
	TStaticText *StaticText40;

        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall SingleFileClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall derivTBChange(TObject *Sender);
        void __fastcall stretchClick(TObject *Sender);
        void __fastcall sldrBrightnessChange(TObject *Sender);
        void __fastcall batch_countClick(TObject *Sender);
		void __fastcall entropyTbChange(TObject *Sender);
        void __fastcall save1Click(TObject *Sender);
        void __fastcall PitchBClick(TObject *Sender);
        void __fastcall EntropyBClick(TObject *Sender);
        void __fastcall FMBClick(TObject *Sender);
        void __fastcall PeakFrBClick(TObject *Sender);
        void __fastcall PitchGoodnessBClick(TObject *Sender);
        void __fastcall DerivPowerBClick(TObject *Sender);
        void __fastcall breakItClick(TObject *Sender);
        void __fastcall back_counterChange(TObject *Sender);
        void __fastcall save_optionsClick(TObject *Sender);
        void __fastcall raw_features1Change(TObject *Sender);
        void __fastcall options1Click(TObject *Sender);
        void __fastcall Delete_recsClick(TObject *Sender);
        void __fastcall test_folderClick(TObject *Sender);
        void __fastcall target_sound_file_folderChange(TObject *Sender);
        void __fastcall data_typeClick(TObject *Sender);
        void __fastcall Draw1Click(TObject *Sender);
        void __fastcall rawfile_nameClick(TObject *Sender);
        void __fastcall BitBtn3Click(TObject *Sender);
        void __fastcall Edit1Click(TObject *Sender);
        void __fastcall new_tableClick(TObject *Sender);
        void __fastcall toExcelClick(TObject *Sender);
        void __fastcall toMatlabClick(TObject *Sender);
        void __fastcall sound_output1Click(TObject *Sender);
        void __fastcall features_output1Click(TObject *Sender);
        void __fastcall test2Click(TObject *Sender);
        void __fastcall BitBtn10Click(TObject *Sender);
        void __fastcall set_slavesClick(TObject *Sender);
        void __fastcall BitBtn4Click(TObject *Sender);
        void __fastcall BitBtn6Click(TObject *Sender);
        void __fastcall BitBtn9Click(TObject *Sender);
        void __fastcall help10Click(TObject *Sender);
        void __fastcall AMClick(TObject *Sender);
        void __fastcall start_formBClick(TObject *Sender);
        void __fastcall BitBtn5Click(TObject *Sender);
        void __fastcall DirectoryListBox1Change(TObject *Sender);
        void __fastcall FileListBox1Change(TObject *Sender);
        void __fastcall FileListBox1Click(TObject *Sender);
        void __fastcall resegmentClick(TObject *Sender);
        void __fastcall open_raw_tableClick(TObject *Sender);
        void __fastcall hatchedChange(TObject *Sender);
        void __fastcall slave_state1Click(TObject *Sender);
        void __fastcall yearChange(TObject *Sender);
        void __fastcall new_file_tableBClick(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall automate_slave_findClick(TObject *Sender);
        void __fastcall ApplicationEvents1Idle(TObject *Sender,
          bool &Done);
        void __fastcall addClick(TObject *Sender);
        void __fastcall table_batch_listMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall table_batch_listKeyPress(TObject *Sender,
          char &Key);
        void __fastcall open_file_tableClick(TObject *Sender);
        void __fastcall openTableClick(TObject *Sender);
        void __fastcall open_file_tblClick(TObject *Sender);
        void __fastcall age_or_dayClick(TObject *Sender);
        void __fastcall char_comp_tbChange(TObject *Sender);
        void __fastcall new_birdClick(TObject *Sender);
        void __fastcall change_raw_tableClick(TObject *Sender);
        void __fastcall SyllMinDurTbChange(TObject *Sender);
        void __fastcall BoutMinDurTBChange(TObject *Sender);
        void __fastcall min_syllablesChange(TObject *Sender);
        void __fastcall BitBtn8Click(TObject *Sender);
        void __fastcall state_transition_TBChange(TObject *Sender);
        void __fastcall missmatchesTbChange(TObject *Sender);
        void __fastcall BitBtn12Click(TObject *Sender);
        void __fastcall add2Click(TObject *Sender);
        void __fastcall multi_tables_listKeyPress(TObject *Sender,
          char &Key);
        void __fastcall multi_tables_listMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall forwardClick(TObject *Sender);
        void __fastcall resetClick(TObject *Sender);
        void __fastcall multi_segmentClick(TObject *Sender);
        void __fastcall create_braintableClick(TObject *Sender);
        void __fastcall BitBtn7Click(TObject *Sender);
        void __fastcall brain_tableClick(TObject *Sender);
        void __fastcall calc_rhythmClick(TObject *Sender);
        void __fastcall colorsChange(TObject *Sender);
        void __fastcall angleXChange(TObject *Sender);
        void __fastcall angleZChange(TObject *Sender);
    void __fastcall test_time_stampClick(TObject *Sender);
    void __fastcall show_filesClick(TObject *Sender);
    void __fastcall features_calcClick(TObject *Sender);
    void __fastcall soundListClick(TObject *Sender);
    void __fastcall formatClick(TObject *Sender);
    void __fastcall batch_modeClick(TObject *Sender);
    void __fastcall batch_choicesClick(TObject *Sender);
    void __fastcall batch_name1Change(TObject *Sender);
    void __fastcall batch_processClick(TObject *Sender);
    void __fastcall to_segmentationClick(TObject *Sender);
    void __fastcall segmentation_doneClick(TObject *Sender);
    void __fastcall wav_selectionClick(TObject *Sender);
    void __fastcall move_optionsClick(TObject *Sender);
    void __fastcall to_outputClick(TObject *Sender);
    void __fastcall save_file_tableClick(TObject *Sender);
    void __fastcall to_reviewClick(TObject *Sender);
    void __fastcall daily_raw_tablesClick(TObject *Sender);
    void __fastcall raw_to_syllClick(TObject *Sender);
    void __fastcall thresh_tableChange(TObject *Sender);
    void __fastcall tablesClick(TObject *Sender);
    void __fastcall table_batch_listClick(TObject *Sender);
    void __fastcall similarity_batchClick(TObject *Sender);
    void __fastcall BitBtn17Click(TObject *Sender);
    void __fastcall files_per_rhythmcalcChange(TObject *Sender);
    void __fastcall rhythm_batchClick(TObject *Sender);
    void __fastcall start_rhythm_batchClick(TObject *Sender);
    void __fastcall rhythms_per_folderChange(TObject *Sender);
    void __fastcall done_rawtosyllClick(TObject *Sender);
    void __fastcall show_rawtosylltablesClick(TObject *Sender);
	void __fastcall segment_byChange(TObject *Sender);
    void __fastcall segmentation_flipClick(TObject *Sender);
    void __fastcall smoothGraphCBClick(TObject *Sender);
    void __fastcall hp_smallChange(TObject *Sender);
    void __fastcall adaptThreshCBClick(TObject *Sender);
    void __fastcall hp_bigChange(TObject *Sender);
    void __fastcall secondaryFeatureCBClick(TObject *Sender);
    void __fastcall secondaryFeatureDDChange(TObject *Sender);
    void __fastcall secondaryComparisonRBClick(TObject *Sender);
    void __fastcall secondaryLogicRBClick(TObject *Sender);
    void __fastcall min_stop_durTbChange(TObject *Sender);
    void __fastcall bout_stopChange(TObject *Sender);
	void __fastcall frequency_rangeChange(TObject *Sender);
	void __fastcall data_windowChange(TObject *Sender);
	void __fastcall advanceChange(TObject *Sender);
	void __fastcall Draw2Click(TObject *Sender);
	void __fastcall saveClick(TObject *Sender);
	void __fastcall goto_parametersClick(TObject *Sender);
	void __fastcall pitch_methodClick(TObject *Sender);
	void __fastcall minfr_tbChange(TObject *Sender);
	void __fastcall min_syllable_durTbChange(TObject *Sender);


     //   void __fastcall UpDown1Changing(TObject *Sender,
    //      bool &AllowChange);
      //  void __fastcall MMSpinButton1DownClick(TObject *Sender);
     //   void __fastcall MMSpinButton1UpClick(TObject *Sender);
private:	// User declarations

CZT_FeatureCalc            m_Calculator;
CWavIterator wave_files[11];
TDateTime bird_hatched;
bool table_batch, num_slaves, deduct, got_data, doing_rhythm_batch;
bool ActiveList;
int total_count, start, stop, back_count, recnum, slave_chans, files_processed, files_accepted, msCounter;
int count_slaves(), lookfor_slave_files();
void populate_raw_tables();
void update_table_names();
bool set_slave_directory(int slave_num, TFileListBox* slave_list, TEdit* folder_name);
bool ready_to_go();
void processFile(), do_table_batch();
bool doit, counting,first_time, new_embeded_file(TDateTime tm);
Graphics::TBitmap *Sonogram;
AnsiString str, Raw_Table, database, raw_features_database;
void Get_raw_Table_attributes(), Get_brain_table_attribute();
void get_age();
void identify_bird();
void note_dur();
float calculate_rhythm();
void hide_all_features();
void plot_sonogram();
void update_segmentation_params();

//TEvent *Event1;//=new TEvent();
//void __fastcall MyIdleHandler(TObject *Sender, bool &Done);
//TEvent idle;
public:		// User declarations
        __fastcall Tbatch(TComponent* Owner);
        void __fastcall CreateParams(Controls::TCreateParams &Params);
        void Calc(AnsiString fileName);
        AnsiString SoundFile;
		bool change_the_table;
		void segment_sf(TObject *Sender);
		void save_frame_sf(TObject *Sender);
		void hp_smallChange_sf(TObject *Sender);
		void secondaryFeatureCBClick_sf(TObject *Sender);

};

void __fastcall Tbatch::CreateParams(Controls::TCreateParams &Params)
{
  TForm::CreateParams(Params);
  Params.ExStyle   = Params.ExStyle | WS_EX_APPWINDOW;
  Params.WndParent = ParentWindow;
}
//---------------------------------------------------------------------------
extern PACKAGE Tbatch *batch;
//---------------------------------------------------------------------------
#endif
